OUTPUT_ARCH(arm)

MEMORY
{
	RAMX (rx) : ORIGIN = 0x101312D0, LENGTH = 0x000BF00
	RAMRW (rw!i) : ORIGIN = 0x104BD2D0, LENGTH = 0x00002000
}

SECTIONS
{
	.text : ALIGN(0x04) {
		build/crt0.o(.init)
		*(.text)
	}
	.rodata : {
		*(.rodata*)
	}
	_bss_start = .;
	.bss : {
		*(.bss);
	}
	_bss_end = .;
}

