#include "types.h"
#include "socket.h"
#include "logger.h"
#include "utils.h"
#include "fsa.h"

void byte_to_str(char in, char * out){
    const char foo[] = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F' };
    int val_up = ((in >> 4) & 0x0F);
    int val_low = (in & 0x0F);
    if((val_up >= 0 && val_up < 16) &&
       (val_low >= 0 && val_low < 16)) {
        out[0] = foo[val_up];
        out[1] = foo[val_low];
    }
    out[2] = ' ';
    out[3] = '\0';
}

void int_to_str(u32 value,char * out){
    byte_to_str(((value >> 24) & 0xFF),&out[0]);
    byte_to_str(((value >> 16) & 0xFF),&out[2]);
    byte_to_str(((value >> 8) & 0xFF),&out[4]);
    byte_to_str(((value >> 0) & 0xFF),&out[6]);
}

void _main()
{
    void (*ios_dflush)(void *ptr, unsigned int len) = (void (*)(void *, unsigned int))0x1012ED4C;
    void (*ios_shutdown)(int) = (void (*)(int))0x1012EE4C;

    int handle = socketInit();
    int log_socket = log_init(handle, 0xC0A800B5);
    //! the first call seems buggy and the 2nd works
    log_socket = log_init(handle, 0xC0A800B5);

    log_print(handle, log_socket, "Don't share your OTP!!!\n");


    char out[0x1000];
    char * cur = out;

    int j = 0;
    for(int i = 0;i<0x400;i++){
        byte_to_str(*(volatile char*)(0x00130000 + i),cur);
        cur += 0x03;
        j++;
        if(j >= 16){
            cur[-1] = '\n';
            j = 0;
        }
    }
    cur[0] = '\0';

    log_print(handle, log_socket, out);

    int (*thread_yield)(void) = (int (*)(void)) 0x1012EB04;


	while(1)
    {
        thread_yield();
    }

    ios_shutdown(1);
}
