
void* memcpy(void *dst, const void *src, unsigned int len)
{
    const unsigned char *src_ptr = (const unsigned char *)src;
    unsigned char *dst_ptr = (unsigned char *)dst;

    while(len)
    {
        *dst_ptr++ = *src_ptr++;
        --len;
    }
    return dst;
}

void* memset(void *dst, int val, unsigned int bytes)
{
    unsigned char *dst_ptr = (unsigned char *)dst;
    unsigned int i = 0;
    while(i < bytes)
    {
        dst_ptr[i] = val;
        ++i;
    }
    return dst;
}

int strlen(const char* str) {
    unsigned int i = 0;
    while (str[i]) {
        i++;
    }
    return i;
}

char *strncpy(char *s, const char *ct, unsigned int n) {
    char *saver = s;

    while(n--)
        *saver++ = *ct++;
    *saver = '\0';

    return s;
}
